using System;
using System.Collections.Generic;
using System.Threading;

namespace ConsoleApplication1
{
	class Class1
	{
		[STAThread]
		static void Main(string[] args)
		{
      Stack<int> sti = new Stack<int>();

      for (int i = 0; i < 10; i++)
      {
        sti.Push(i);
      }

      MyThread m1 = new MyThread();
      MyThread m2 = new MyThread();

      Thread th1 = m1.StartThread(sti, 1);
      Thread th2 = m2.StartThread(sti, 2);

      th1.Start();
      th2.Start();

      th1.Join();
      th2.Join();
		}
	}

  class MyThread
  {
    Stack<int> sti;
    int iNr;

    public Thread StartThread(Stack<int> st, int i)
    {
      sti = st;
      iNr = i;

      Thread th = new Thread(new ThreadStart(Output));

      return th;
    }

    private void Output()
    {
      foreach (int i in sti)
      {
        Console.Write("{0}:  {1}     ", iNr, i);
      }
    }
  }

  class Stack<MyType>
  {
    MyType [] arrData = new MyType[10];
    int iCount;

    public Stack()
    {
      iCount = 0;
    }

    public void Push(MyType t)
    {
      arrData[iCount] = t;
      iCount++;
    }

    public MyType Pop()
    {
      MyType t = arrData[iCount - 1];
      iCount--;

      return t;
    }

    public IEnumerator<MyType> GetEnumerator()
    {
      for (int i = iCount - 1; i >= 0; i--)
      {
        yield return arrData[i];
      }
    }

    public int Count
    {
      get
      {
        return iCount;
      }
    }
  }
}
