using System;
using System.Threading;

class App 
{
  public static void Main() 
  {
    // Fr Synchronisierung
    AutoResetEvent asyncOpIsDone = new AutoResetEvent(false);

    // Thread aus ThreadPool aktivieren
    ThreadPool.QueueUserWorkItem(new WaitCallback(MyAsyncOperation), asyncOpIsDone);

    Console.WriteLine("Haupt-Thread luft jetzt hier weiter.....");
    // ...

    Console.WriteLine("Haupt-Thread wartet jetzt darauf, dass der Thread fertig wird......");
    asyncOpIsDone.WaitOne();
    Console.WriteLine("Alles fertig!!!");
  }

  // delegate (hat immer den Parameter Object und gibt nichts zurck)
  static void MyAsyncOperation(Object state) 
  {
    Console.WriteLine("Thread: Jetzt wird hier asynchron 'geackert'......");
    // ...
    
    double dSum = 0.0;

    for(int i = 0; i < 10000; i++)
	    dSum += Math.Sqrt(i);
    
    // Jetzt ist die Aktion abgeschlossen.
    ((AutoResetEvent)state).Set();
  }
}