using System;
using System.Threading;

class Calc
{
  public static double Add(double d1, double d2) 
  { 
    return (d1 + d2); 
  }
}

class EntryPoint
{
  // delegate deklarieren
  delegate double Add(double x, double y);

  static double dResult;	

  // Signal fr Threadsynchronisation
  static AutoResetEvent evDone = new AutoResetEvent(false);

  // Funktion, die beim Methodenende aufgerufen wird
  static void CallBackProc(IAsyncResult asyncCall)
  {
    Add add = (Add)asyncCall.AsyncState;
    dResult = add.EndInvoke(asyncCall);

    Console.Write("--- Fertig! ---");
    evDone.Set();
  }

  // Asynchroner Methodenaufruf
  static double DoSomething(Add add)
  {
    AsyncCallback cb = new AsyncCallback(CallBackProc);
    IAsyncResult ar = add.BeginInvoke(3, 4, cb, add);

    // Etwas tun....
    for (int i = 0; i < 1000; i++) 
    { 
      Console.Write("."); 
    }

    // Wenn die Methode eher als der Workerthread
    // fertig ist, dann auf Ende des Threads warten
    evDone.WaitOne();

    return dResult;
  }

  static void Main()
  {
    // Add-Methode deklarieren
    Add addMethod = new Add(Calc.Add);

    dResult = DoSomething(addMethod);
    Console.WriteLine("Ergebnis: {0}", dResult);
  }
}
