using System;
using System.Threading;

namespace Thread1
{
  public class MathClass2
  {
    private int iStart, iEnde;
    private double dSum;
    private bool bCompleted;

    public Thread Calculate(int i1, int i2)
    {
      bCompleted = false;

      iStart = i1;
      iEnde = i2;

      Thread th = new Thread(new ThreadStart(CalcBackground));

      return th;
    }

    private void CalcBackground()
    {
      dSum = 0.0;

      for(int i = iStart; i < iEnde; i++)
      {
        dSum += Math.Sqrt(i);
      }

      bCompleted = true;
    }

    public double Result
    {
      get
      {
        return dSum;
      }
    }

    public bool IsReady
    {
      get
      {
        return bCompleted;
      }
    }
  }

  public class class1
  {
    [STAThread]
    static void Main(string[] args)
    {
      MathClass2 mc1 = new MathClass2();
      Thread th1 = mc1.Calculate(0, 50000000);
      th1.Priority = ThreadPriority.AboveNormal;
      th1.Start();

      MathClass2 mc2 = new MathClass2();
      Thread th2 = mc2.Calculate(50000000, 100000000);
      th2.Priority = ThreadPriority.BelowNormal;
      th2.Start();

      th1.Join();

      th2.Abort();

      Console.WriteLine("Thread 1 fertig: {0}\nThread 2 fertig: {1}", 
        mc1.IsReady, mc2.IsReady);
      Console.WriteLine("Gesamtergebnis: {0}", mc1.Result + mc2.Result);
    }
  }
}
