using System;
using System.Threading;

namespace Thread1
{
  public class MathClass2
  {
    private int iStart, iEnde;
    private double dSum;
    private bool bCompleted;

    public Thread Calculate(int i1, int i2)
    {
      bCompleted = false;

      iStart = i1;
      iEnde = i2;

      Thread th = new Thread(new ThreadStart(CalcBackground));

      return th;
    }

    private void CalcBackground()
    {
      int i = 0;

      dSum = 0.0;

      try
      {
        for(i = iStart; i < iEnde; i++)
        {
          dSum += Math.Sqrt(i);
        }

        bCompleted = true;
      }
      catch(ThreadAbortException e)
      {
        // Hier Aufrumen....
        Console.WriteLine("Exception im Thread: {0}", e.Message);
        Thread.Sleep(5000);
        Console.WriteLine("Berechnung bis i = {0} durchgefhrt.", i);
      }
    }

    public double Result
    {
      get
      {
        return dSum;
      }
    }

    public bool IsReady
    {
      get
      {
        return bCompleted;
      }
    }
  }

  public class class1
  {
    [STAThread]
    static void Main(string[] args)
    {
      MathClass2 mc = new MathClass2();
      Thread th = mc.Calculate(0, 500000000);
      th.Start();

      Thread.Sleep(1000);
      Console.WriteLine("Jetzt der erste Abort...");
      th.Abort();
      Thread.Sleep(1000);
      Console.WriteLine("...und jetzt nochmal aborten...");
      th.Abort();
//      th.Join();
  
      Console.WriteLine("Ergebnis: {0}", mc.Result);
    }
  }
}
