using System;
using System.Threading;

namespace Thread1
{
  public class MathClass2
  {
    private int iStart, iEnde;
    private double dSum;
    private bool bCompleted;

    public Thread Calculate(int i1, int i2)
    {
      bCompleted = false;

      iStart = i1;
      iEnde = i2;

      Thread th = new Thread(new ThreadStart(CalcBackground));

      return th;
    }

    private void CalcBackground()
    {
      int i = 0;

      dSum = 0.0;

      try
      {
        for(i = iStart; i < iEnde; i++)
        {
          dSum += Math.Sqrt(i);
        }

        bCompleted = true;
      }
      catch(ThreadAbortException e)
      {
        // Hier Aufrumen....
        Console.WriteLine("Exception im Thread: {0}", e.Message);
        Console.WriteLine("Berechnung bis i = {0} durchgefhrt.", i);
      }
    }

    public double Result
    {
      get
      {
        return dSum;
      }
    }

    public bool IsReady
    {
      get
      {
        return bCompleted;
      }
    }

    public bool SaveAbort(Thread th)
    {
      if((th.ThreadState == ThreadState.SuspendRequested) ||
         (th.ThreadState == ThreadState.Suspended))
      { 
        th.Priority = ThreadPriority.Lowest;  // Thread soll mglichst wenig tun
        th.Resume();                       

        while(th.ThreadState == ThreadState.Suspended)
        { 
          Thread.Sleep(50);
        }
      }

      th.Abort();

      return true;
    }
  }

  public class class1
  {
    [STAThread]
    static void Main(string[] args)
    {
      MathClass2 mc1 = new MathClass2();
      Thread th1 = mc1.Calculate(0, 1000000);
      th1.Priority = ThreadPriority.AboveNormal;
      th1.Start();

      MathClass2 mc2 = new MathClass2();
      Thread th2 = mc2.Calculate(10000000, 1000000000);
      th2.Priority = ThreadPriority.BelowNormal;
      th2.Start();

      th1.Join();
      th2.Suspend();
  
      Thread.Sleep(100);

      try
      {
        th2.Abort();
//      mc2.SaveAbort(th2);
      }
      catch(Exception ex)
      {
        Console.WriteLine("Abort geht nicht!!! Message: " + ex.Message);
      }

      Console.WriteLine("Gesamtergebnis: {0}", mc1.Result + mc2.Result);
    }
  }
}
