using System;
using System.Threading;

namespace Thread1
{
  public class MathClass3
  {
    private int iStart, iEnde;
    private double dSum;

    public Thread Calculate(int i1, int i2)
    {
      iStart = i1;
      iEnde = i2;

      Thread th = new Thread(new ThreadStart(CalcBackground));
      
      return th;
    }

    private void CalcBackground()
    {
      dSum = 0.0;

      for(int i = iStart; i < iEnde; i++)
      {
        dSum += Math.Sqrt(i);
      }
    }

    public double Result
    {
      get
      {
        return dSum;
      }
    }
  }

  public class MathClass2
  {
    private int iStart, iEnde;
    private double dSum;

    public Thread Calculate(int i1, int i2)
    {
      iStart = i1;
      iEnde = i2;

      Thread th = new Thread(new ThreadStart(CalcBackground));
      
      return th;
    }

    private void CalcBackground()
    {
      MathClass3 mc3 = new MathClass3();
      Thread th3 = mc3.Calculate(iStart, iEnde);

      th3.Start();
      th3.Join();

      dSum = mc3.Result;
    }

    public double Result
    {
      get
      {
        return dSum;
      }
    }
  }

  public class class1
  {
    [STAThread]
    static void Main(string[] args)
    {
      MathClass2 mc1 = new MathClass2();
      Thread th1 = mc1.Calculate(0, 50000000);
      th1.Start();

      MathClass2 mc2 = new MathClass2();
      Thread th2 = mc2.Calculate(50000000, 100000000);
      th2.Start();

      // Abort ist hier mglich, obwohl der Neben-Thread im Wait-Status
      // (=Join) ist. Ist nicht wie mit Suspend und Abort!!!

//      Thread.Sleep(100);
//      th1.Abort();

      th1.Join();
      th2.Join();

      Console.WriteLine("Gesamtergebnis: {0}", mc1.Result + mc2.Result);
    }
  }
}
