using System;
using System.Threading;

namespace Thread1
{
  public class MathClass2
  {
    private int iStart, iEnde;
    private double dSum;
    private bool bCompleted;

    public Thread Calculate(int i1, int i2)
    {
      bCompleted = false;

      iStart = i1;
      iEnde = i2;

      Thread th = new Thread(new ThreadStart(CalcBackground));

      return th;
    }

    private void CalcBackground()
    {
      int i = 0;

      dSum = 0.0;

      try
      {
        try
        {
          for(i = iStart; i < iEnde; i++)
          {
            dSum += Math.Sqrt(i);
          }

          bCompleted = true;
        }
        finally
        {
          Console.WriteLine("Beginn von finally.");
          Thread.Sleep(5000);    // Hier sollte der Abort-Befehl kommen
          Console.WriteLine("Ende von finally.");
        }
      }
      catch(ThreadAbortException e)
      {
        // Hier Aufrumen....
        Console.WriteLine("Exception im Thread: {0}", e.Message);
        Console.WriteLine("Berechnung bis i = {0} durchgefhrt.", i);
      }
    }

    public double Result
    {
      get
      {
        return dSum;
      }
    }

    public bool IsReady
    {
      get
      {
        return bCompleted;
      }
    }
  }

  public class class1
  {
    [STAThread]
    static void Main(string[] args)
    {
      MathClass2 mc = new MathClass2();
      Thread th = mc.Calculate(0, 50000);
      th.Start();

      Thread.Sleep(1000);
      th.Abort();
      th.Join();

      Console.WriteLine("Ende des Programms.");
    }
  }
}
