using System;
using System.Threading;

namespace Thread1
{
  public class MathClass2
  {
    private int iStart, iEnde;
    private double dSum;
    private bool bCompleted;
    private Thread th;

    public Thread Calculate(int i1, int i2)
    {
      bCompleted = false;

      iStart = i1;
      iEnde = i2;

      th = new Thread(new ThreadStart(CalcBackground));

      return th;
    }

    private void CalcBackground()
    {
      int i = 0;

      dSum = 0.0;

      try
      {
        for(i = iStart; i < iEnde; i++)
        {
          dSum += Math.Sqrt(i);
        }

        bCompleted = true;
        th.Abort();  // Pseudo-finally "aufrufen"
      }
      catch(ThreadAbortException ex)
      {
        // *** PSEUDO-LSUNG FR DAS FINALLY-PROBLEM ***
        // Hier Pseudo-finally:
        // Wenn Abort aufgerufen wird, dann landet man hier
        // Wenn try zu Ende, dann landet man auch hier
        // Wenn Fehler in try, dann landet man auch hier
        // WICHTIG: try muss mit thread.Abort beendet werden
        // Aufrumcode muss nur EINMAL implementiert werden

        Console.WriteLine("Beginn von Pseude-finally.");
        Console.WriteLine("Message: {0}", ex.Message);
        Thread.Sleep(5000);    // Hier sollte der Abort-Befehl kommen
        Console.WriteLine("Ende von Pseudo-finally.");
      }
    }

    public double Result
    {
      get
      {
        return dSum;
      }
    }

    public bool IsReady
    {
      get
      {
        return bCompleted;
      }
    }
  }

  public class class1
  {
    [STAThread]
    static void Main(string[] args)
    {
      MathClass2 mc = new MathClass2();
      Thread th = mc.Calculate(0, 50000);
      th.Start();

      Thread.Sleep(1000);
//      th.Abort();
//      Console.WriteLine("*** Abort ***");
      th.Join();

      Console.WriteLine("Ende des Programms.");
    }
  }
}
