using System;
using System.Threading;
using System.Windows.Forms;

namespace WinCancel
{
	public class Calc
	{
    private int iStart;
    private int iEnde;
    private double dSum;
    private FinishFunc finalMeth;
    private UpdateProgress progMeth;
    private int iStep;
    private Form form;

		public Thread CalcStart(int i1, int i2, Form fo, FinishFunc f, UpdateProgress p)
		{
      iStart = i1;
      iEnde = i2;
      finalMeth = f;
      progMeth = p;
      form = fo;

      iStep = (iEnde - iStart) / 100;

      Thread th = new Thread(new ThreadStart(Calculate));

      return th;
		}

    private void Calculate()
    {
      try
      {
        dSum = 0.0;

        for(int i = iStart; i < iEnde; i++)
        {
          CheckProgress(i);

          dSum += Math.Sqrt(i);
        }
      }
      finally
      {
        // Wird auch bei Thread.Abort() aufgerufen
         
        form.Invoke(finalMeth);
      }
    }

    private void CheckProgress(int i)
    {
      if(i % iStep == 0)
      {
        form.Invoke(progMeth);
      }
    }

    public double Result
    {
      get
      {
        return dSum;
      }
    }
	}
}
