using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace WinCancel
{
  public delegate void FinishFunc();
  public delegate void UpdateProgress();

  public class Form1 : System.Windows.Forms.Form
	{
    private System.Windows.Forms.Button buttonStart;
    private System.Windows.Forms.Button buttonExit;
    private System.Windows.Forms.TextBox textOut;
		private System.ComponentModel.Container components = null;
    private Thread th = null;
    private System.Windows.Forms.ProgressBar progBar;
    private Calc c;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.buttonStart = new System.Windows.Forms.Button();
      this.buttonExit = new System.Windows.Forms.Button();
      this.textOut = new System.Windows.Forms.TextBox();
      this.progBar = new System.Windows.Forms.ProgressBar();
      this.SuspendLayout();
      // 
      // buttonStart
      // 
      this.buttonStart.Location = new System.Drawing.Point(8, 16);
      this.buttonStart.Name = "buttonStart";
      this.buttonStart.Size = new System.Drawing.Size(272, 23);
      this.buttonStart.TabIndex = 0;
      this.buttonStart.Text = "&Berechnung starten";
      this.buttonStart.Click += new System.EventHandler(this.buttonStart_Click);
      // 
      // buttonExit
      // 
      this.buttonExit.Enabled = false;
      this.buttonExit.Location = new System.Drawing.Point(8, 56);
      this.buttonExit.Name = "buttonExit";
      this.buttonExit.Size = new System.Drawing.Size(272, 23);
      this.buttonExit.TabIndex = 1;
      this.buttonExit.Text = "Berechnung beenden";
      this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
      // 
      // textOut
      // 
      this.textOut.Location = new System.Drawing.Point(8, 96);
      this.textOut.Name = "textOut";
      this.textOut.Size = new System.Drawing.Size(272, 20);
      this.textOut.TabIndex = 2;
      this.textOut.Text = "";
      // 
      // progBar
      // 
      this.progBar.Location = new System.Drawing.Point(8, 128);
      this.progBar.Name = "progBar";
      this.progBar.Size = new System.Drawing.Size(272, 23);
      this.progBar.Step = 1;
      this.progBar.TabIndex = 3;
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(292, 166);
      this.Controls.Add(this.progBar);
      this.Controls.Add(this.textOut);
      this.Controls.Add(this.buttonExit);
      this.Controls.Add(this.buttonStart);
      this.Name = "Form1";
      this.Text = "WinCancel";
      this.ResumeLayout(false);

    }
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

    private void buttonStart_Click(object sender, System.EventArgs e)
    {
      FinishFunc meth = new FinishFunc(Fertig);
      UpdateProgress prog = new UpdateProgress(PaintProgress);

      c = new Calc();
      th = c.CalcStart(0, 100000000, this, meth, prog);
      th.Start();

      buttonExit.Enabled = true;
      buttonStart.Enabled = false;
    }

    private void buttonExit_Click(object sender, System.EventArgs e)
    {
      if(th != null)
      {
        th.Abort();
        textOut.Text = c.Result.ToString();
        th = null;
      }

      buttonExit.Enabled = false;
      buttonStart.Enabled = true;
    }

    private void Fertig()
    {
      buttonExit.Enabled = false;
      buttonStart.Enabled = true;

      progBar.Value = 0;

      textOut.Text = "Fertig: " + c.Result.ToString();
    }

    private void PaintProgress()
    {
      progBar.Value += progBar.Step;
    }
	}
}
