using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Forms;
using System.Windows.Markup;
using System.IO;

namespace DynamicStyles
{
  /// <summary>
  /// Interaction logic for Window1.xaml
  /// </summary>

  public partial class Window1 : Window
  {
    public Window1()
    {
      InitializeComponent();
    }

    public void OnFileOpen(object sender, EventArgs e)
    {
      OpenFileDialog dlg = new OpenFileDialog();

      dlg.Filter = "XAML Files (*.xaml)|*.xaml|All Files (*.*)|*.*";
      dlg.FilterIndex = 0;

      if (dlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
      {
        using (FileStream fs = new FileStream(dlg.FileName, FileMode.Open, FileAccess.Read))
        {
          ResourceDictionary dict = (ResourceDictionary)XamlReader.Load(fs);
          this.Resources = dict;
          fs.Close();
        }
      }
    }

    public void OnFileExit(object sender, EventArgs e)
    {
      this.Close();
    }

    public void OnClicked(object sender, EventArgs e)
    {
      System.Windows.MessageBox.Show("Button mit Spezial-Design!");
    }
  }
}